<!-- <link rel="import" href="../polymer/polymer-element.html"> -->
<script src="../Snap.svg/dist/snap.svg-min.js"></script>

<script src="lib/snap/SnapText.js"></script>
<script src="lib/snap/SnapRectangle.js"></script>
<script src="lib/snap/SnapTriangle.js"></script>
<script src="lib/snap/SnapView.js"></script>
<script src="lib/snap/SnapResizeDecorator.js"></script>

<script src="lib/ResizeDecoratorsCollection.js"></script>

<script src="lib/ShapeFactory.js"></script>
<script src="lib/shapes/Shape.js"></script>
<script src="lib/shapes/Rectangle.js"></script>
<script src="lib/shapes/Triangle.js"></script>
<script src="lib/shapes/VerticalLine.js"></script>

<script src="lib/GrobFactory.js"></script>
<script src="lib/GrobsMediator.js"></script>
<script src="lib/GrobGrid.js"></script>
<script src="lib/Grob.js"></script>

<script src="lib/Line.js"></script>
<script src="lib/LinesGroup.js"></script>

<script src="lib/Background.js"></script>

<script src="lib/CanvasView.js"></script>
<script src="lib/CanvasEvent.js"></script>
<script src="lib/Canvas.js"></script>

<link rel="import" href="../iron-ajax/iron-ajax.html">
<link rel="import" href="../dez-scroll/dez-scroll.html">
<link rel="import" href="../iron-a11y-keys/iron-a11y-keys.html">

<!--

@demo ./demo/index.html Demo

-->

<dom-module id="dez-canvas">

    <template>

        <style>

            :host {
                display: flex;
                flex-direction: column;
            }

            dez-scroll {
                flex-grow: 1;
            }

            .vertical-line-line {
              opacity: 0.25;
            }

            .vertical-line-text {
              text-anchor: middle;
            }

            .vertical-line-text, .grob-text {
              opacity: 0.8;
              font-family: 'Roboto', 'Noto', sans-serif;
              font-size: 130%;
              font-weight: bold;
            }

        </style>

        <iron-a11y-keys
            id="a11y"
            target="[[target]]"
            keys="delete backspace"
            on-keys-pressed="_handleKeyPress">
        </iron-a11y-keys>

        <dez-scroll id="scrollContainer">
            <svg id="canvasSvg"></svg>
        </dez-scroll>


        <iron-ajax
          id="gridFileRequest"
          url="{{gridFile}}"
          handle-as="json"
          debounce-duration="300"
          auto
          on-response="_gridReady">
        </iron-ajax>

        <iron-ajax
            id="grobsFileRequest"
            url="{{grobsFile}}"
            handle-as="json"
            debounce-duration="300"
            auto
            on-response="_grobsReady">
        </iron-ajax>


    </template>

    <script>

        class DezCanvas extends Polymer.GestureEventListeners(Polymer.Element) {

            static get is() { return 'dez-canvas'; }

            static get properties() {
                return {
                    bg: {
                        type: String,
                        observer: '_updateBg'
                    },
                    zoom: {
                        type: Number,
                        value: 1,
                        observer: '_zoomChanged'
                    },
                    gridData: {
                        type: Object,
                        observer: '_updateGridData'
                    },
                    gridFile: {
                        type: String,
                        observer: '_updateGridFile'
                    },
                    grobsData: Array,
                    grobsFile: String,
                    notInteractive: {
                        type: Boolean,
                        notify: false
                    },
                    scrollLeft: {
                        type: Number,
                        value: 0,
                        observer: '_scrollLeftChanged',
                        reflectToAttribute: true,
                        notify: true
                    },
                    target: Object,
                    cursor: {
                      type: Number,
                      observer: '_cursorChanged'
                    }
                }
            }

            _zoomChanged () {
              console.log("zoom changed -> ", this.zoom);
              if (this._snapView != undefined) {
                this._snapView.zoom = this.zoom
              }
            }

            _cursorChanged () {
              if (this.canvasView) {
                if (this.cursor != undefined) {
                  let rightEdge = window.innerWidth + this.scrollLeft
                  let margin = window.innerWidth/10
                  let zoomedCursor = this.cursor * this.zoom
                  let cursorVisible = this.scrollLeft <= zoomedCursor && zoomedCursor <= rightEdge
                  let cursorInsideMargins = this.scrollLeft + margin <= zoomedCursor && zoomedCursor <= rightEdge - margin
                  if (cursorVisible && !cursorInsideMargins) {
                    this.scrollLeft = zoomedCursor - margin
                  }
                  this.canvasView.showCursorOn(this.cursor)
                } else {
                  this.canvasView.deleteCursor()
                }
              }
            }

            _scrollLeftChanged () {
                this.$.scrollContainer.scroll(this.scrollLeft);
            }

            _fireGrobChangedEvent (grob, action) {
                this.dispatchEvent(
                    new CustomEvent('grob-changed', {
                        detail : {
                            id: grob.id,
                            x: grob.x,
                            width: grob.width,
                            text: grob.shape.text,
                            linesIds: grob.parents
                            .map(line => line.id)
                            .sort((a,b)=>a-b),
                            action: action
                        }
                    }
                ))
            }

            setDefaultValues(defautValues) {
                this._shapeFactory.shapeDefaults = defautValues;
            }

            add(data) {
                let shape = this._shapeFactory.create(data.shape)
                shape.text = data.text;
                shape.color = data.color;
                this._grob = this._grobFactory.create(data.x, data.width, shape);
                return this;
            }

            onLine(id) {
                if (id == 'all') {
                    this._canvas.add(this._grob).onAllLines();
                } else {
                    this._canvas.add(this._grob).onLineId(id)
                }
                return this;
            }

            getId() { return this._grob.id; }

            updateGrob (data) {
                let grob = this._grobFactory.get(data.id);
                if (data.width == 0  && grob.shape.constructor.name != 'VerticalLine') {
                    grob.shape = this._shapeFactory.create('VerticalLine');
                }
                if (data.width > 0  && grob.shape.constructor.name != 'Rectangle') {
                    grob.shape = this._shapeFactory.create('Rectangle');
                }
                grob.shape.text = data.text;
                grob.shape.color = data.color;
                grob.resize(data.width);
                grob.moveTo(data.x);
                if (data.line != 'all') {
                  this._canvas.move(grob).toLineIdOn(data.line)
                }
            }

            selectGrob (id) {
              this._grobFactory.get(id).select();
            }

            deleteGrob (id) {
                this._grobFactory.remove(id);
                this._canvas.deleteGlobal(id);
            }

            deleteGrobs () {
                this._grobFactory.removeAll();
                this._canvas.deleteGlobals();
            }

            deleteLines () {
                this._canvas.deleteLines();
            }

            _formatedIndexes (indexes) {
                let ret = []
                let si = indexes.sort((a,b) => a-b);
                for (let i = si[0]; i <= si[si.length-1]; i++) {
                    ret.push(i);
                }
                return ret;
            }

            _populateCanvas (grobsData) {
                grobsData.forEach(data =>{
                    let shape = this._shapeFactory.create(data.type);
                    shape.color = data.color;
                    shape.text =  data.text;
                    shape.direction = data.direction;
                    let grob = this._grobFactory.create(data.x, data.lg, shape);
                    this._formatedIndexes(data.lines).forEach(
                        index => this._canvas
                          .add(grob)
                          .onLineId("staves." + parseInt(index+1))
                    );
                });
            }

            /* ------------------- */

            async _init () {
              this._snapView = new SnapView(this.$.canvasSvg, this.zoom)
              this.canvasView = new CanvasView(this._snapView)
              this._canvas = new Canvas(this.canvasView)
              if (this.gridData) {
                this._updateGridData()
              }
              this._shapeFactory = new ShapeFactory(this._snapView);
              this._grobFactory = new GrobFactory(
                new GrobsMediator(),
                this._grid
              )
              if (this.bg) {
                await this._updateBg()
              }
              if (this.grobsData && !this._gridFileLoading) {
                this._populateCanvas(this.grobsData)
              }
              if (this.cursor) {
                this._cursorChanged()
              }
            }

            /* ------------------- */

            async _updateBg () {
              if (this.canvasView) {
                await this.canvasView.setBackground(this.bg);
              }
            }

            _updateGridData () {
              if (this._canvas) {
                this._canvas.updateOrAddLines(this.gridData.lines);
                this._grid.positions = this.gridData.positions;
                this._scrollLeftChanged()
                this._snapView.fitToHeight(this.clientHeight)
                this.zoom =  this._snapView.zoom
              }
            }

            _updateGridFile () {
              this._gridFileLoading = true
            }

            _gridReady (event) {
              this.gridData = event.detail.response
              this._updateGridData()
              if (this.grobsData) {
                this._populateCanvas(this.grobsData)
              }
              if (this.cursor) {
                this._cursorChanged()
              }
              this._gridFileLoading = false
            }

            _grobsReady (event) {
              this.grobsData = event.detail.response
              this._populateCanvas(this.grobsData)
              if (this.cursor) {
                this._cursorChanged()
              }
            }

            /* ------------------- */

            constructor () {
              super()
              this._grid = new GrobGrid()
              this._gridFileLoading = false
            }

            ready () {
                super.ready();
                this._init ();
                if (!this.notInteractive) {
                    this._touchMoveDisabled = false
                    Polymer.Gestures.addListener(this, 'tap', e => this._handleTap(e));
                    Polymer.Gestures.addListener(this, 'track', e => this._handleTrack(e));
                    Polymer.Gestures.addListener(this, 'down', e => this._handleDown(e));
                    this.addEventListener("touchmove", e => {
                      if (this._touchMoveDisabled) {
                        e.preventDefault()
                      }
                    })
                    this.target = this;
                }
                this.$.scrollContainer.addEventListener(
                    'scroll-left-changed',
                    e => this.scrollLeft = e.detail.scrollLeft
                )
                this._ensureAttribute('tabindex', 0);
            }

            _handleKeyPress (event) {
                this._fireGrobChangedEvent(this._grobSelected, "DELETE");
                this.deleteGrob(this._grobSelected.id)
            }

            /* ------------------- */

            _createGrobOnTrack (canvasEvent) {
                if (canvasEvent.state == "track") {
                    if (this._grobToCreate == undefined) return;
                    const VL_WIDTH = 15
                    if (Math.abs(canvasEvent.dx) > VL_WIDTH) {
                        if (this._grobToCreate.shape instanceof VerticalLine) {
                            this._grobToCreate.shape = this._shapeFactory.create("Rectangle");
                            this._fireGrobChangedEvent(this._grobToCreate, "MUTATED");
                        }
                        this._grobToCreate.resize(Math.abs(canvasEvent.dx), canvasEvent.dx<0?"LEFT":"RIGHT", true)
                        this._fireGrobChangedEvent(this._grobToCreate, "RESIZED");
                    } else {
                        if (!(this._grobToCreate.shape instanceof VerticalLine) ) {
                            this._grobToCreate.shape = this._shapeFactory.create("VerticalLine");
                            this._grobToCreate.moveTo(canvasEvent.ox, true)
                            this._grobToCreate.resize(0, true)
                            this._fireGrobChangedEvent(this._grobToCreate, "MUTATED");
                        }
                    }
                    this._lastNbLines = this._grobToCreate.parents.length;
                    this._canvas
                        .add(this._grobToCreate)
                        .from(canvasEvent.oy)
                        .toY(canvasEvent.y);
                    this._newNbLines = this._grobToCreate.parents.length;
                    if (this._newNbLines != this._lastNbLines) {
                        this._fireGrobChangedEvent(this._grobToCreate, "MUTATED");
                    }
                } else if (canvasEvent.state == "end") {
                    this._grobToCreate = undefined;
                    this._touchMoveDisabled = false
                }
            }

            _resizeGrobOnTrack(canvasEvent, direction) {
                if (canvasEvent.state == "start") {
                    this._oWidth = this._grob.width;
                } else if (canvasEvent.state == "track") {
                    let newWidth = this._oWidth + (direction=="LEFT"?-1:1)*canvasEvent.dx;
                    this._grob.resize(newWidth, direction, true);
                } else if (canvasEvent.state == "end") {
                  this._touchMoveDisabled = false
                }
                this._fireGrobChangedEvent(this._grob, "RESIZED");
            }

            _moveGrobOnTrack (canvasEvent) {
                if (canvasEvent.state == "start") {
                    if (this._grob == undefined) return;
                    this._origin = {
                        xInGrob: canvasEvent.x - this._grob.x,
                        top: this._grob.top,
                        bottom: this._grob.bottom
                    }
                    this._fireGrobChangedEvent(this._grob, "MOVED");
                } else if (canvasEvent.state == "track") {
                    if (this._grob == undefined) return;
                    let newX = canvasEvent.x - this._origin.xInGrob;
                    this._grob.moveTo(newX, true, true);
                    this._canvas.move(this._grob).toLineOn(canvasEvent.y)
                    this._fireGrobChangedEvent(this._grob, "MOVED");
                } else if (canvasEvent.state == "end") {
                  this._touchMoveDisabled = false
                  return;
                }
            }

            _handleTrack (event) {
                this._mouseHasTracked = true;
                let canvasEvent = this.canvasView.createEvent(event);
                if (canvasEvent.target == "background") {
                    this._createGrobOnTrack(canvasEvent);
                } else if (canvasEvent.target == "right-resize-decorator") {
                    this._resizeGrobOnTrack(canvasEvent, "RIGHT");
                } else if (canvasEvent.target == "left-resize-decorator") {
                    this._resizeGrobOnTrack(canvasEvent, "LEFT");
                } else if (canvasEvent.target == "rect") {
                    this._moveGrobOnTrack(canvasEvent);
                }
            }

            _createGrobOnTap (canvasEvent) {
                let shape = this._shapeFactory.create("VerticalLine")
                this._grobToCreate = this._grobFactory.create(canvasEvent.x, 0, shape, true);
                try {
                    this._canvas.add(this._grobToCreate).on(canvasEvent.y);
                    this._grobToCreate.select();
                    this._fireGrobChangedEvent(this._grobToCreate, "CREATED");
                } catch (e) {}
            }

            _selectGrob (canvasEvent, moveCursor) {
                this._grob = this._canvas.grobOn(canvasEvent.x, canvasEvent.y);
                if (this._grob) {
                    this._grob.select();
                    this._fireGrobChangedEvent(this._grob, "SELECTED");
                    if (moveCursor)
                        this._fireGrobChangedEvent(this._grob, "PLAY");
                    this.focus();
                    this._grobSelected = this._grob;
                }
            }

            _handleTap (event) {
                this._mouseIsDown = false;
                let canvasEvent = this.canvasView.createEvent(event)
                if (event.detail.sourceEvent.shiftKey && canvasEvent.target == "background") {
                  if (this.cursor != undefined) {
                    this.cursor = canvasEvent.x
                    this.dispatchEvent(new CustomEvent('cursor-changed'))
                  }
                }
            }

            /**
             * Get actual first point tapped. On fast move, track.start events
             * are fired later than down event and the (x,y) are sometimes not
             * correct.
             */
            _handleDown (event) {
                let tempo = 300;
                this._mouseIsDown = true;
                this._mouseHasTracked = false;
                this._downTimeStamp = event.timeStamp;
                this._grobToCreate = undefined
                let canvasEvent = this.canvasView.createEvent(event);
                if (canvasEvent.target != "background" && canvasEvent.targetIsGrob) {
                    event.preventDefault()
                    this._selectGrob (canvasEvent, event.detail.sourceEvent.shiftKey);
                } else {
                    setTimeout(() => {
                        if (this._mouseIsDown && !this._mouseHasTracked && this._downTimeStamp == event.timeStamp) {
                            this._touchMoveDisabled = true
                            this._createGrobOnTap (canvasEvent);
                        }
                    }, tempo);
                }
            }

        }

        customElements.define(DezCanvas.is, DezCanvas);

    </script>

</dom-module>
